;--------------------------------------------------------------------
;   Eject Script for Portable Apps Menu
;  (c) 2007 Karl McMurdo (XrXca)
;--------------------------------------------------------------------
AutoItSetOption('TrayIconHide', 1)
AutoItSetOption('MustDeclareVars', 1)

Global $Version = '0.4'
; Check to see if we are doing the self delete thing
If ($CmdLine[0] = 2) Then
	If (StringInStr(@ScriptFullPath, '\_EJS')) And (StringInStr($CmdLine[1], '\_EJS')) And ( $CmdLine[2] = 'DoSelfDelete' ) Then
		SelfDelete($CmdLine[1])
	EndIf
EndIf

; Get Path we are in
Local $Path = @ScriptDir
If (StringRight($Path, 1) <> '\') Then $Path &= '\'
; My Full Path
Local $Me = @ScriptFullPath
; Ini File Path
Local $Ini = StringLeft($Me, StringLen($Me) - 3) & 'ini'
; Base Filename
Local $Basename = StringLeft(@ScriptName, StringLen(@ScriptName) - 4)
; Default Drive to Eject
Local $Drive = StringLeft($Me, 2)
; Command to run to show the remove hardware dialog
Local $ShowDialog = 'Rundll32.exe Shell32,Control_RunDLL hotplug.dll'

If Not @Compiled Then $Drive = 'J:'  ; Set for testing

#Region Localized Text
Local $MsgCount = 17
Global $Text[$MsgCount][2] = [ _
		['Title', 'Portable Device Eject'], _
		['CanBeEjected', 'The drive can be ejected when all files are closed.'], _
		['CloseOnDrive', 'Close Any Programs or Files Open on Drive X:'], _
		['LangExists', 'Locale File Exists, Add any Missing Lines?'], _
		['IniExists', 'Config INI File Exists, Replace with Default?'], _
		['AppsWin', 'Applications With Windows'], _
		['AppsNoWin', 'Applications Without Windows'], _
		['NoApps', 'No Applications Found'], _
		['Prompt', 'OK to try closing applications running on drive X:'], _
		['EjectPrompt', 'OK to Try Ejecting Drive X:'], _
		['ErrTitle', 'Portable Device Eject Error'], _
		['ErrBadDrive', 'This is not a recognized drive type.'], _
		['ErrNoDrive', 'Drive Not Found'], _
		['ErrType', 'Drives of this type can not be ejected.'], _
		['ErrSysDrive', 'The drive containing operating system can not be ejected'], _
		['ErrTempDrive', 'The drive where Temporary files are stored can not be ejected'], _
		['ErrUnknown', 'Unknown Error'] ]
#EndRegion Localized Text

#Region MessageVars
; moved here so we can get locale specific default promtps in the ini file (if required)
Local $Locale = IniRead($Ini, "CONFIG", "LANG", "none")
If FileExists($Path & $Basename & '_' & $Locale & '.locale') Then
	Local $LocaleFile = $Path & $Basename & '_' & $Locale & '.locale'
	For $i = 0 To $MsgCount - 1
		$Text[$i][1] = IniRead($LocaleFile, "MESSAGES", $Text[$i][0], $Text[$i][1])
	Next
Else
	$Locale = 'none';
EndIf

; Set MSG Variables
For $i = 0 To $MsgCount - 1
	If ($Text[$i][0] <> '') Then Assign('MSG_' & $Text[$i][0], StringReplace($Text[$i][1], 'X:', $Drive))
Next
#EndRegion MessageVars

#Region IniData
Local $IniCount = 58
Local $IniLines[$IniCount][3] = [ _
		['DESCRIPT', $Basename & ' Configuration File', 'n/a'], _
		['', '', 'n/a'], _
		['', '[CONFIG]', 'n/a'], _
		['VERSION', '', $Version], _
		['', '', 'n/a'], _
		['LANG', 'Selected Language', 'none'], _
		['', '', 'n/a'], _
		['ASKFIRST', 'Prompt the user to before trying to close any applications (0/1)', '0'], _
		['ASKFIRSTTIMEOUT', 'Timeout for the Ask First Prompt (Seconds)', '300'], _
		['ASKFIRSTDEFAULT', 'Default if the askfirst prompt times out (0/1) (1 = Yes, 0 = No)', '0'], _
		['ASKFIRSTPROMPT', 'Text to use for ASKFIRST', StringReplace($MSG_Prompt, $Drive, 'X:')], _
		['', '', 'n/a'], _
		['FIXEDOK', 'A "Fixed" type drive CAN be ejected (USB Hard Drive) (0/1)', '1'], _
		['', '', 'n/a'], _
		['QUIET', 'Quiet Mode (1/0, 1 means enabled) if set to 1 will not display ANY messages', '0'], _
		['', '', 'n/a'], _
		['SHOWDIALOG', 'Show Safely Remove Hardware Dialog (1/0)', '1'], _
		['', '', 'n/a'], _
		['EJECTEXE', 'EJECT Exe, the Executable that will be run at end of this script', ''], _
		['EJECTPRM', 'Command Line Parameters sent to the EJECTEXE program, X: will be replaced with the drive to eject', ''], _
		['EJECTHID', 'Run the Eject EXE Hidden (1/0)', '1'], _
		['EJECTDEL', 'This script should handle deleting the EJECTEXE program from %TEMP% after it runs (0/1)', '0'], _
		['EJECTASK', 'Prompt the user to before runing the eject exe (0/1)', '0'], _
		['EJECTASKTIMEOUT', 'Timeout for the Ask Before Ejecting Prompt (Seconds)', '300'], _
		['EJECTASKDEFAULT', 'Default if the askfirst prompt times out (0/1) (1 = Yes, 0 = No)', '0'], _
		['EJECTASKPROMPT', 'Text to use for EJECTASK', StringReplace($MSG_EjectPrompt, $Drive, 'X:')], _
		['', '', 'n/a'], _
		['TIPTIME', 'Miniumun number of seconds the popup tip should display, the script will run for at least this time', '3'], _
		['', '', 'n/a'], _
		['FORCETIME', 'Number of seconds to wait for forced time items to close before killing the specified processes', '5'], _
		['', '', 'n/a'], _
		['NOWINTIME', 'Number of seconds to wait AFTER FORCETIME has expired before killing specified processes with no window', '5'], _
		['', '', 'n/a'], _
		['APP_FORCETIME1', 'Paths to executables that should be FORCED closed afer FORCETIME seconds', 'n/a'], _
		['APP_FORCETIME2', 'X: will be replaced with the drive being ejected, the left side can be anything', 'n/a'], _
		['APP_FORCETIME3', 'but are usually numbers 0=, 1= etc.   The FULL path, is required', 'n/a'], _
		['APP_FORCETIME4', 'For Example: 0=X:\PortableApps\SomeAppPortable\App\SomeAppName.exe', 'n/a'], _
		['APP_FORCETIME5', 'Remember that the app will not get a chance to clean up after itself', 'n/a'], _
		['', '[APP_FORCETIME]', 'n/a'], _
		['', '0=X:\Full\Path\To\App.exe', 'n/a'], _
		['', '', 'n/a'], _
		['APP_FORCEALWAYS', 'Paths to executables that should just be killed immediately', 'n/a'], _
		['', '[APP_FORCEALWAYS]', 'n/a'], _
		['', '0=X:\Full\Path\To\App.exe', 'n/a'], _
		['', '', 'n/a'], _
		['APP_NOWINKILL1', 'Paths to executables that have no windows that should be killed after NOWINTIME seconds', 'n/a'], _
		['APP_NOWINKILL2', 'This should almost NEVER be used, to get a list of applications running off the portable', 'n/a'], _
		['APP_NOWINKILL3', 'drive, run  ' & @ScriptName & ' /SHOW, it will open a list of apps with and without windows', 'n/a'], _
		['', '[APP_NOWINKILL]', 'n/a'], _
		['', '0=X:\Full\Path\To\App.exe', 'n/a'], _
		['', '', 'n/a'], _
		['APP_SHOW', 'Paths to executables whos windows should be shown, but not closed', 'n/a'], _
		['', '[APP_SHOW]', 'n/a'], _
		['', '0=X:\Full\Path\To\App.exe', 'n/a'], _
		['', '', 'n/a'], _
		['APP_IGNORE', 'Paths to executables we should just ignore', 'n/a'], _
		['', '[APP_IGNORE]', 'n/a'], _
		['', '0=X:\Full\Path\To\App.exe', 'n/a'] ]
#EndRegion IniData

#Region SetIniVars
; Set Ini Variables
; So its a bit convoluted If I want a new var in the config, I just add it to the config section above and
; the variable is available, same with APP_ sections.
Dim $Temp = ''
Dim $TempArray
Dim $TempC
If FileExists($Ini) Then
	For $i = 0 To $IniCount - 1
		If ($IniLines[$i][2] <> 'n/a') Then
			Assign('INI_' & $IniLines[$i][0], StringReplace(IniRead($Ini, 'CONFIG', $IniLines[$i][0], $IniLines[$i][2]), 'X:', $Drive))
		ElseIf ($IniLines[$i][0] = '') And (StringRegExp($IniLines[$i][1], '^\[APP_[A-Za-z0-9_]*\]$')) Then
			$Temp = StringMid($IniLines[$i][1], 2, StringLen($IniLines[$i][1]) - 2)
			$TempArray = IniReadSection($Ini, $Temp)
			If (@error) Then
				Dim $TempArray[1][1] = [['0']]
			ElseIf $TempArray[0][0] > 0 Then
				$TempC = 0
				For $j = 1 To $TempArray[0][0]
					If (StringLeft($TempArray[$j][1], 3) = 'X:\') And ($TempArray[$j][1] <> 'X:\Full\Path\To\App.exe') Then
						$TempC += 1
						$TempArray[$TempC][0] = $Drive & StringMid($TempArray[$j][1], 3)
					EndIf
				Next
				$TempArray[0][0] = $TempC
			EndIf
			Assign($Temp, $TempArray)
		EndIf
	Next
Else
	For $i = 0 To $IniCount - 1
		If ($IniLines[$i][2] <> 'n/a') Then
			Assign('INI_' & $IniLines[$i][0], $IniLines[$i][2])
		EndIf
	Next
	Dim $App_ForceTime[1][1] = [['0']]
	Dim $App_ForceAlways[1][1] = [['0']]
	Dim $App_Show[1][1] = [['0']]
	Dim $App_Ignore[1][1] = [['0']]
	Dim $App_NoWinKill[1][1] = [['0']]
EndIf

$Ini_TipTime = $Ini_TipTime * 1000
$Ini_ForceTime = $Ini_ForceTime * 1000

#EndRegion SetIniVars


#Region IniLocale
; Load Locale Specific INI Strings
Local $Locale = IniRead($Ini, "CONFIG", "LANG", "none")
If FileExists($Path & $Basename & '_' & $Locale & '.locale') Then
	Local $LocaleFile = $Path & $Basename & '_' & $Locale & '.locale'
	For $i = 0 To $IniCount - 1
		If $IniLines[$i][0] <> '' Then
			$IniLines[$i][1] = IniRead($LocaleFile, "INICOMMENTS", $IniLines[$i][0], $IniLines[$i][1])
		EndIf
	Next
Else
	$Locale = 'none';
EndIf
#EndRegion IniLocale


#Region CommandLine
Dim $JustShow = False
If ($CmdLine[0] <> 0) Then ; Handle Command Line Options
	If (StringRegExp($CmdLine[1], '^[A-Za-z]:$') = 1) Then
		$Drive = $CmdLine[1]
	ElseIf ( $CmdLine[1] = '/show') Then
		$JustShow = True
	ElseIf ( $CmdLine[1] = '/ini') Then
		If (FileExists($Ini)) Then
			If MsgBox(4, $MSG_Title, $MSG_IniExists) <> 6 Then
				Exit
			EndIf
		EndIf
		Local $File = FileOpen($Ini, 2)
		For $i = 0 To $IniCount - 1
			If $IniLines[$i][0] = '' Then
				FileWriteLine($File, $IniLines[$i][1])
			Else
				if $IniLines[$i][1] <> '' Then
					FileWriteLine($File, '; ' & $IniLines[$i][1])
				EndIf
				If $IniLines[$i][2] <> 'n/a' Then
					FileWriteLine($File, $IniLines[$i][0] & '=' & $IniLines[$i][2])
				EndIf
			EndIf
		Next
		FileClose($File)
		ShellExecute($Ini)
		Exit
	ElseIf (StringRegExp($CmdLine[1], '^[A-Za-z0-9][A-Za-z0-9_-]*[A-Za-z0-9]$')) Then
		Local $LocaleFile = $Path & $Basename & '_' & $CmdLine[1] & '.locale'
		If FileExists($LocaleFile) Then
			If MsgBox(4, $MSG_Title, $MSG_LangExists) = 6 Then
				For $i = 0 To $MsgCount - 1
					IniWrite($LocaleFile, "MESSAGES", StringUpper($Text[$i][0]), IniRead($LocaleFile, "MESSAGES", $Text[$i][0], $Text[$i][1]))
				Next
				For $i = 0 To $IniCount - 1
					If $IniLines[$i][0] <> '' Then
						IniWrite($LocaleFile, "INICOMMENTS", StringUpper($IniLines[$i][0]), IniRead($LocaleFile, "INICOMMENTS", $IniLines[$i][0], $IniLines[$i][1]))
					EndIf
				Next
			EndIf
		Else
			Local $File = FileOpen($LocaleFile, 2)
			FileWriteLine($File, '; ' & $Basename & ' Language File')
			FileWriteLine($File, '; NOTE: Make sure "X:" remains in any modified text (it will be replaced with the correct drive)')
			FileClose($File)
			IniWrite($LocaleFile, $Basename, 'LANGID', $CmdLine[1])
			IniWrite($LocaleFile, $Basename, 'NOTE', 'Make sure "X:" remains in any modified text (it will be replaced with the correct drive)')
			For $i = 0 To $MsgCount - 1
				IniWrite($LocaleFile, "MESSAGES", StringUpper($Text[$i][0]), $Text[$i][1])
			Next
		EndIf
		ShellExecute("Notepad.exe", $LocaleFile)
		Exit
	Else
		Usage()
	EndIf
	If ($CmdLine[0] > 1) Then ; Handle Command Line Options
		If (StringRegExp($CmdLine[2], '^[A-Za-z]:$') = 1) Then
			$Drive = $CmdLine[2]
		ElseIf ( $CmdLine[2] = '/show') Then
			$JustShow = True
		EndIf
	EndIf
EndIf
#EndRegion CommandLine
;

If $JustShow Then
	Dim $ProgList[5000][1]
	$ProgList[0][0] = 0
	Dim $WinCount = 0
	Dim $Path
	Dim $WinList = WinList()
	Dim $AppFile = StringLeft($Me, StringLen($Me) - 3) & 'lst'
	Dim $File = FileOpen($AppFile, 2)
	FileWriteLine($File, $Basename & ' ' &$Version)
	FileWriteLine($File, "--------------------------")
	For $i = 1 To $WinList[0][0]
		$Path = GetExePathFromWindow($WinList[$i][1])
		If ( StringLeft($Path,2) = $Drive ) and ( $Path <> $Me )Then
			If ( not CheckPath($Path, $ProgList) ) Then
				$ProgList[0][0] += 1
				$ProgList[$ProgList[0][0]][0] = $Path
				if ( $WinCount = 0 ) Then
					FileWriteLine($File, $MSG_AppsWin)
				EndIf
				FileWriteLine($File, $Path)
				$WinCount += 1
			EndIf
		EndIf
	Next
	Dim $PIDList = ProcessList()
	Dim $PIDCount = 0
	For $i = 1 To $PIDList[0][0]
		$Path = GetExePathFromPID($PIDList[$i][1])
		If ( StringLeft($Path,2) = $Drive ) and ( $Path <> $Me )Then
			If ( not CheckPath($Path, $ProgList) ) Then
				$ProgList[0][0] += 1
				$ProgList[$ProgList[0][0]][0] = $Path
				if ( $PIDCount = 0 ) Then
					FileWriteLine($File, '')
					FileWriteLine($File, $MSG_AppsNoWin)
				EndIf
				$PIDCount += 1
				FileWriteLine($File, $Path)
			EndIf
		EndIf
	Next
	If $PIDCount + $WinCount > 0  Then
		FileWriteLine($File, "--------------------------")
	Else
		FileWriteLine($File, $MSG_NoApps)
	EndIf
	FileWriteLine($File, "DriveType for " & $Drive & " = " & DriveGetType($Drive))
	FileClose($File)
	run('notepad.exe ' & $AppFile)
	Exit
EndIf
	

; Do we thing we can eject this drive type?
If $Drive = StringLeft(@WindowsDir, 2) Then ExitError($Msg_ErrSysDrive) ; Can't Eject System Drive
If $Drive = StringLeft(@TempDir, 2) Then ExitError($Msg_ErrTempDrive) ; or the Temp Drive
If DriveGetType($Drive) = '' Then ExitError($MSG_ErrNoDrive) ; Not on a Removeable Drive
Dim $RemoveableTypes = " REMOVABLE CDROM ";
if ( $Ini_FixedOK == 1 ) then $RemoveableTypes &= "FIXED "
If Not StringInStr($RemoveableTypes, DriveGetType($Drive)) Then ExitError($Msg_ErrType) ; Not on a Removeable Drive

; Prompt to continue
if ($Ini_AskFirst == 1) Then
	Local $SecondButton = 0
	if ( $Ini_AskFirstDefault == 0 ) then
		$SecondButton = 256
	EndIf
	Local $Result = MsgBox(4 + 32 + $SecondButton + 262144, $Msg_Title, $Ini_AskFirstPrompt, $Ini_AskFirstTimeout)
	if ( $Result == 7 ) or ( ( $Result == -1 ) and ( $Ini_AskFirstDefault == 0 ) ) then 
		Exit
	EndIf
EndIf

If ($Ini_Quiet = 0) Then ToolTip($MSG_CanBeEjected, Default, Default, $MSG_CloseOnDrive, Default, 4)

Local $Start = TimerInit() ; Save the start time

#Region FirstLoop
; Try to close any windows that are running off the drive
Dim $ForceWindows[5000]
$ForceWindows[0] = 0
Global $WinList = WinList()
Local $Path = ''
Local $Title
Local $HWnd
Local $Repeats = 2
Local $Found = 1
while ( $Repeats > 0 ) and ( $Found = 1 )
	$Found = 0
	$Repeats -= 1
	For $i = 1 To $WinList[0][0]
		$Title = $WinList[$i][0]
		$HWnd = $WinList[$i][1]
		$Path = GetExePathFromWindow($HWnd)
		; Is this app on the removeable drive?
		If StringLeft($Path, 2) == $Drive Then
			$Found = 1
			If ForceKill($Path) Then
				WinKill($WinList[$i][1])
				$ForceWindows[0] += 1
				$ForceWindows[$ForceWindows[0]] = $HWnd
			ElseIf ShowApp($Path) Then
				WinActivate($HWnd)
			ElseIf Not IgnoreApp($Path) Then
				WinClose($HWnd)
				If (ForceTime($Path)) Then ; Build List of Windows to force on timeout
					$ForceWindows[0] += 1
					$ForceWindows[$ForceWindows[0]] = $HWnd
				EndIf
			EndIf
		ElseIf StringInStr($Title, $Drive & '\') Or StringInStr($Title, '(' & $Drive & ')') Then
			WinClose($HWnd)
		EndIf
	Next
	if ( $Found = 1 ) Then Sleep(50)
WEnd
#EndRegion FirstLoop

#Region SetupOtherExe
; Copy the eject file and setup selfdelete while waiting on timeouts (if any)
Local $RunExe = False
Local $DelExe = False
If ($Ini_EjectExe <> '') Then
;	If ( $Ini_EjectCpy <> 0 ) Then
		$RunExe = TempCopy($Ini_EjectExe)
		If $RunExe Then
			If ($Ini_EjectDel <> 0) and @Compiled Then
				$DelExe = TempCopy($Me)
			EndIf
		EndIf
;	Else
;		$RunExe = $Ini_EjectExe;
;	EndIf
EndIf
#EndRegion SetupOtherExe

#Region ForceLoops
While (TimerDiff($Start) < $Ini_ForceTime) And ($ForceWindows[0] > 0)
	$Temp = 1
	While $Temp <= $ForceWindows[0]
		If WinExists($ForceWindows[$Temp]) Then
			$Temp += 1
		Else
			$ForceWindows[$Temp] = $ForceWindows[$ForceWindows[0]]
			$ForceWindows[0] -= 1
		EndIf
	WEnd
	Sleep(100) ; Give the Windows Another 10th of a Second
WEnd
; If any remain, try a WinKill
If $ForceWindows[0] > 0 Then
	Dim $StillThere = False
	For $Temp = 1 To $ForceWindows[0]
		If WinExists($ForceWindows[$Temp]) Then
			WinKill($ForceWindows[$Temp])
			$StillThere = True
		EndIf
	Next
	; If we had to try Winkilling wait a half a sec and then go for the big gun (ProcessClose)
	if $StillThere Then
		Sleep(500)
		For $Temp = 1 To $ForceWindows[0]
			If WinExists($ForceWindows[$Temp]) Then
				ProcessClose(WinGetProcess($ForceWindows[$Temp]))
			EndIf
		Next
	EndIf
EndIf
If $App_NoWinKill[0][0] > 0 Then
	Dim $ProcWait = TimerDiff($Start)
	Dim $ProcToKill[100][2]
	$ProcToKill[0][0] = 0
	Dim $PIDList = ProcessList()
	For $i = 1 To $PIDList[0][0]
		$Path = GetExePathFromPID($PIDList[$i][1])
		If ( StringLeft($Path,2) = $Drive ) Then
			If ( NoWinKill($Path) ) Then
				If ( not CheckPath($Path, $ProcToKill) ) Then
					$ProcToKill[0][0] += 1
					$ProcToKill[$ProcToKill[0][0]][0] = $Path
				EndIf
			EndIf
		EndIf
	Next
	If $ProcToKill[0][0] > 0 Then
		$ProcWait = TimerDiff($Start) - $ProcWait
		If $ProcWait > 0 Then Sleep($ProcWait)
		Dim $PIDList = ProcessList()
		For $i = 1 To $PIDList[0][0]
			$Path = GetExePathFromPID($PIDList[$i][1])
			If ( StringLeft($Path,2) = $Drive ) Then
				If ( CheckPath($Path, $ProcToKill) ) Then
					ProcessClose($PIDList[$i][1])
				EndIf
			EndIf
		Next
	EndIf
EndIf
#EndRegion ForceLoops

If $RunExe Then
	Local $Abort = False
	if ($Ini_EjectAsk == 1) Then
		Local $SecondButton = 0
		if ( $Ini_EjectAskDefault == 0 ) then
			$SecondButton = 256
		EndIf
		Local $Result = MsgBox(4 + 32 + $SecondButton + 262144, $Msg_Title, $Ini_EjectAskPrompt, $Ini_EjectAskTimeout)
		if ( $Result == 7 ) or ( ( $Result == -1 ) and ( $Ini_EjectAskDefault == 0 ) ) then 
			$Abort = True
		EndIf
	EndIf
	if ( $Abort ) Then
		; Clean up files copied while waiting if we're aborting
;		if $Ini_EjectCpy Then
		FileDelete($RunExe)
;		EndIf
		if ( $DelExe ) Then
			FileDelete($DelExe)
		EndIf
	Else
		If $Ini_EjectHid = 1 Then
			$Ini_EjectHid = @SW_HIDE
		Else
			$Ini_EjectHid = @SW_SHOW
		EndIf
		Run($RunExe & ' ' & $Ini_EjectPrm, @TempDir, $Ini_EjectHid)
		If $DelExe Then
			Run($DelExe & ' "' & $RunExe & '" DoSelfDelete', @TempDir, @SW_HIDE)
		EndIf
	EndIf
EndIf

If StringInStr(" CDROM ", DriveGetType($Drive)) Then
	CDTray($Drive, "open") ; This May or may not work
ElseIf $Ini_ShowDialog <> 0 Then
	Run($ShowDialog, @TempDir, @SW_HIDE)
EndIf

If ($Ini_Quiet = 0) Then
	Dim $Runtime = TimerDiff($Start)
	If $Runtime < $Ini_TipTime Then Sleep($Ini_TipTime - $Runtime) ; If tip displayed for less than specified time give it a chance to be seen
EndIf

Exit

#Region Functions

Func ForceKill($CheckPath) ; Check to see if app is in forcekill list
	Return (CheckPath($CheckPath, $App_ForceAlways))
EndFunc   ;==>ForceKill

Func ForceTime($CheckPath) ; Check to see if app is in timed forcekill list
	Return (CheckPath($CheckPath, $App_ForceTime))
EndFunc   ;==>ForceTime

Func ShowApp($CheckPath) ; Check to see if app is in show list
	Return (CheckPath($CheckPath, $App_Show))
EndFunc   ;==>ShowApp

Func IgnoreApp($CheckPath) ; Check to see if app is in ignore list
	Return (CheckPath($CheckPath, $App_Ignore) or ($CheckPath = $Me))
EndFunc   ;==>IgnoreApp

Func NoWinKill($CheckPath) ; Check to see if app is in no window kill list
	Return (CheckPath($CheckPath, $App_NoWinKill))
EndFunc   ;==>IgnoreApp

Func CheckPath(ByRef $CheckPath, ByRef $AppList) ; Check Path Against an App List
	Local $Result = False
	If ($AppList[0][0] > 0) Then
		For $x = 1 To $AppList[0][0]
			If ($CheckPath = $AppList[$x][0]) Then
				$Result = True
				ExitLoop
			EndIf
		Next
	EndIf
	Return ($Result)
EndFunc   ;==>CheckPath

Func GetExePathFromWindow($Window) ; Get the path of a Window
	Return(GetExePathFromPID(WinGetProcess($Window)))
EndFunc
	
Func GetExePathFromPID($PID)
	Local $ExePath = ''
	Local $ProcessHandle = DllCall('kernel32.dll', 'hwnd', 'OpenProcess', 'int', BitOR(0x0400, 0x0010), 'int', 0, 'int', $PID)
	If $ProcessHandle[0] <> 0 Then
		Local $ModuleHandleArray = DllStructCreate('int[1024]')
		DllCall('psapi.dll', 'int', 'EnumProcessModules', 'hwnd', $ProcessHandle[0], 'ptr', DllStructGetPtr($ModuleHandleArray), _
		        'int', DllStructGetSize($ModuleHandleArray), 'int_ptr', 0)
		Local $DLLResult = DllCall('psapi.dll', 'int', 'GetModuleFileNameEx', 'hwnd', $ProcessHandle[0], _
		                         'int', DllStructGetData($ModuleHandleArray, 1), 'str', '', 'int', 2048)
		If $DLLResult[0] > 0 Then
			$ExePath = $DLLResult[3]
		EndIf
	EndIf
	Return $ExePath
EndFunc   ;==>GetExePathFromWindow

Func TempCopy($Src) ; Copy a file to a temporary name in %TEMP% directory with same extension
	If Not FileExists($Src) Then
		SetError(1)
		Return (False)
	EndIf
	Local $TempFile = $Src
	Local $Ext = ''
	While (StringInStr('.\', StringLeft($Ext, 1)) = 0) And ($TempFile <> '')
		$Ext = StringRight($TempFile, 1) & $Ext
		$TempFile = StringLeft($TempFile, StringLen($TempFile) - 1)
	WEnd
	If StringLeft($Ext, 1) <> '.' Then
		$Ext = '' ; No Extension
	EndIf
	Do
		$TempFile = @TempDir & '\_EJS' & Chr(Random(97, 122, 1)) & Chr(Random(97, 122, 1)) & Chr(Random(97, 122, 1)) & Chr(Random(97, 122, 1)) & $Ext
	Until Not FileExists($TempFile)
	If FileCopy($Src, $TempFile) = 0 Then
		SetError(2)
		Return (False)
	Else
		Return ($TempFile)
	EndIf
EndFunc   ;==>TempCopy

Func ExitError($Message) ; Exit Showing an Error MEsssage (If no Quiet)
	If ($Ini_Quiet = 0) Then 
		MsgBox(16, 'Portable Device Eject', $Message)
		Usage()
	Else
		Exit(1)
	EndIf
EndFunc   ;==>ExitError

Func Usage() ; Display Usage Information
	Local $Usage = 'Usage:' & @LF _
			 & '  ' & StringUpper($Basename) & ' [/?] [/INI] [/SHOW] [X:] [lang]' & @LF & @LF _
			 & '   /?     Show This Help Message' & @LF _
			 & '   /INI   Create ' & $Basename & '.ini With all default values' & @LF _
			 & '   /SHOW  Show any Applications Running on Current Drive' & @LF _
			 & '   X:     Try Closing Applications Running on Drive X:' & @LF _
			 & '   lang   Create a blank Locale file ' & $Basename & '_lang.locale' & @LF _
			 & '          the file must NOT already exist, "lang" will be what is' & @LF _
			 & '          used in the ini entry LANG= to set the language, it must' & @LF _
			 & '          be at least 2 characters long, and can contain only' & @LF _
			 & '          letters numbers _ and - (but can not start or end with' & @LF _
			 & '          either _ or -.  Short but self explanitory is best.' & @LF _
			 & '' & @LF _
			 & '                                     Version: ' & $Version
	MsgBox(0, 'Portable Device Eject', $Usage);
	Exit (1)
EndFunc   ;==>Usage

Func SelfDelete($File) ; Delete A File (Keep Trying Till We Can Delete It) And Then Delete Self and Exit
	While FileExists($File)
		If (FileDelete($File) = 0) Then Sleep(200) ; Wait a while for next try
	WEnd
	Run(@ComSpec & ' /c DEL "' & @ScriptFullPath & '" >> NUL', @TempDir, @SW_HIDE)
	Exit
EndFunc   ;==>SelfDelete

#EndRegion	Functions
